/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.bonita.facade.impl;

import org.ow2.bonita.facade.APIAccessor;
import org.ow2.bonita.facade.CommandAPI;
import org.ow2.bonita.facade.ManagementAPI;
import org.ow2.bonita.facade.RuntimeAPI;
import org.ow2.bonita.facade.internal.InternalAPIAccessor;
import org.ow2.bonita.util.AccessorProxyUtil;

public class StandardAPIAccessorImpl extends StandardQueryAPIAccessorImpl implements APIAccessor {

  private final InternalAPIAccessor internalAccessor = StandardInternalAPIAccessorFactory.getStandardInternalAPIAccessor();

  public RuntimeAPI getRuntimeAPI() {
    final Class<RuntimeAPI> clazz = RuntimeAPI.class;
    return AccessorProxyUtil.getClientAPI(clazz, this.internalAccessor.getRuntimeAPI());
  }

  public ManagementAPI getManagementAPI() {
    final Class<ManagementAPI> clazz = ManagementAPI.class;
    return AccessorProxyUtil.getClientAPI(clazz, this.internalAccessor.getManagementAPI());
  }

  public CommandAPI getCommandAPI() {
    final Class<CommandAPI> clazz = CommandAPI.class;
    return AccessorProxyUtil.getClientAPI(clazz, this.internalAccessor.getCommandAPI());
  }

}


