/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.bonita.facade.impl;

import org.ow2.bonita.facade.QueryAPIAccessor;
import org.ow2.bonita.facade.QueryDefinitionAPI;
import org.ow2.bonita.facade.QueryRuntimeAPI;
import org.ow2.bonita.facade.internal.InternalQueryAPIAccessor;
import org.ow2.bonita.util.AccessorProxyUtil;
import org.ow2.bonita.util.EnvConstants;

public class StandardQueryAPIAccessorImpl implements QueryAPIAccessor {

  private final InternalQueryAPIAccessor internalQueryAccessor =
    StandardInternalAPIAccessorFactory.getStandardInternalQueryAPIAccessor();

  public StandardQueryAPIAccessorImpl() {
  }

  public QueryRuntimeAPI getQueryRuntimeAPI() {
    return getQueryRuntimeAPI(EnvConstants.DEFAULT_QUERIER);
  }

  public QueryRuntimeAPI getQueryRuntimeAPI(final String queryList) {
    final Class<QueryRuntimeAPI> clazz = QueryRuntimeAPI.class;
    return AccessorProxyUtil.getClientAPI(clazz, this.internalQueryAccessor.getQueryRuntimeAPI(), queryList);
  }

  public QueryDefinitionAPI getQueryDefinitionAPI() {
    return getQueryDefinitionAPI(EnvConstants.DEFAULT_QUERIER);
  }
  
  public QueryDefinitionAPI getQueryDefinitionAPI(final String queryList) {
    final Class<QueryDefinitionAPI> clazz = QueryDefinitionAPI.class;
    return AccessorProxyUtil.getClientAPI(clazz, this.internalQueryAccessor.getQueryDefinitionAPI(), queryList);
  }

}


